//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  2
#property indicator_color1   LimeGreen
#property indicator_color2   PaleVioletRed
#property indicator_width1   2
#property indicator_width2   2
#property indicator_minimum -1
#property indicator_maximum  1
#property indicator_level1   0

//
//
//
//
//

extern int    RsiPeriod = 9;
extern int    RsiPrice  = PRICE_CLOSE;
extern double LevelUp1  = 70;
extern double LevelUp2  = 60;
extern double LevelDn2  = 40;
extern double LevelDn1  = 30;

//
//
//
//
//

double trup[];
double trdn[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,trup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,trdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
   IndicatorShortName("RSI swings ("+RsiPeriod+")");
   return(0);
}
 
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      for(int i = limit; i >= 0; i--)
      {
         double rsi = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
            trend[i] = trend[i+1];
            if (rsi<LevelDn2 && trend[i+1] ==  1) trend[i] =  0;
            if (rsi>LevelUp2 && trend[i+1] == -1) trend[i] =  0;
            if (rsi>LevelUp1)                     trend[i] =  1;
            if (rsi<LevelDn1)                     trend[i] = -1;

            //
            //
            //
            //
            //
            
            trup[i] = EMPTY_VALUE;
            trdn[i] = EMPTY_VALUE;
               if (trend[i] ==  1) trup[i] =  1;
               if (trend[i] == -1) trdn[i] = -1;
      }
      return(0);
}